/*  bm_stat : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr */
static char *cvs_id =" $Id: bm_stat.c,v 1.3 2002/12/05 16:20:01 berar Exp $ ";

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#include "prg_def.h"

#include "xy_def.h"
#include "bm_def.h"
#include "edf_def.h"

/* #define DEBUG 1 */
/*-----------------------------------------------------------*/
int chol_part (double * mat, double * vect, int n);
int stat_info(IMAGE *img, char cas);  
/*-----------------------------------------------------------*/
float  dark_coef   = 0;
float  stat_low  = 0.75;
float  stat_high = 0.75;
int    stat_deg = 1;
int    stat_nb = 1;
int    stat_img = 1;
/*-----------------------------------------------------------*/
void use_stat( void )
{  fprintf(stderr, " DARK_COEF =  \n");
   fprintf(stderr, " STAT_DEG =  1 (default)\n");
   fprintf(stderr, " STAT_LOW  =  0.75 (default)\n");
   fprintf(stderr, " STAT_HIGH =  0.75 (default)\n");
   fprintf(stderr, " STAT_NB =  8 (default)\n");
   fprintf(stderr, " STAT_IMG =  1 (default)\n");
   }
/*-----------------------------------------------------------*/
int par_stat( char * tag, char * arg )
{  if (prg_iniflt( tag, arg, "DARK_COEF", &dark_coef))return 0;
   if (prg_iniint( tag, arg, "STAT_DEG", &stat_deg))return 0;
   if (prg_iniflt( tag, arg, "STAT_LOW", &stat_low))return 0;
   if (prg_iniflt( tag, arg, "STAT_HIGH", &stat_high))return 0;
   if (prg_iniint( tag, arg, "STAT_NB", &stat_nb))return 0;
   if (prg_iniint( tag, arg, "STAT_IMG", &stat_img))return 0;
   return 0;
	}
/*-----------------------------------------------------------*/
#define GRAPH_SIZE 256
void  bm_stat( IMAGE *img, COUNTS* d_value, IMAGE *d_img, int set_limit, float low_limit, int print)
{   FRAMES *sn; 
    COUNTS  *s1=img->data; 
    double *s2=img->cosmic.sumq;
    int n = img->used_frames;
    int size = img->size;
    int xs = img->x_size;
    int i, j, m, mkk, rej, essai, ner2, om, passage, repas;
    COUNTS  raw_mi, raw_ma, raw_mean, lim_mi, lim_ma, d_val;
    double nf, moy, s, sig, s2c, rho;
    double *mat, *vec, *omat, *ovec, *coef;
    double residu, oresidu;
    double vmi, vma, ovmi, ovma, smi, sma, omean;
    double er, ern, ers, ers2;
    int study, v, w, vecsize, matsize, vw;
	 char gr_name[100];
	 XY_HDR gr_h;
    IMAGE  gr_img;
	 COUNTS  *gr_data;
	 int gr_data_size;
	 double gr_xma, gr_yma;
	 int    gr_ix, gr_iy, gr_ip, gr_max;
    errno = essai = 0;
    oresidu = 0;
	 gr_data_size=(GRAPH_SIZE*GRAPH_SIZE)*sizeof(COUNTS);
	 gr_data = (COUNTS *) prg_alloc("bm_stat","gr_data",gr_data_size,0);
    sn = (FRAMES *) prg_alloc("bm_stat","sn",size*sizeof(FRAMES),0);
    vecsize=stat_deg+1;
	 matsize = (vecsize*(vecsize+1))/2;
	 mat = (double *) prg_alloc("bm_stat","mat",matsize*sizeof(double),0);
	 omat = (double *) prg_alloc("bm_stat","omat",matsize*sizeof(double),0);
	 vec = (double *) prg_alloc("bm_stat","vec",vecsize*sizeof(double),0);
	 ovec = (double *) prg_alloc("bm_stat","ovec",vecsize*sizeof(double),0);
	 coef = (double *) prg_alloc("bm_stat","vec",vecsize*sizeof(double),0);
    prg_printf ("# statistics on %d frames of %s", n, img->name);
	 gr_img.data = gr_data;
	 gr_img.info.mini = 0;
	 gr_img.x_size=gr_img.x_tsize=GRAPH_SIZE;
	 gr_img.y_size=gr_img.y_tsize=GRAPH_SIZE;
	 gr_img.size=gr_img.tsize=GRAPH_SIZE*GRAPH_SIZE;
	 gr_h.edf_used = 0;
	 gr_img.header = &gr_h;
    if ( d_value )
	 {  prg_printf (" with dark data from %s\n",d_img->name);
	    rho = img->used_frames / (double) d_img->used_frames;
       }
       else prg_printf(" without dark\n");
    if (n == 0 ) return;
    if ( print &  32 && size < XY_PRINTSIZE )
    {  prg_printf( "# corrrected_sum(frames) %d*%d\n", img->y_size, img->x_size);
       for (j=0; j < img->y_size; j++)
       {   prg_printf( "#R(N) %3d :", j);
           for (i=0, m=j*xs; i < xs; i++, m++)  prg_printf(" %6d(%2d)", s1[m], img->frame[m]);
           prg_printf("\n");
        }  }
    if ( print & 256 && size < XY_PRINTSIZE )
    {  prg_printf( "# mean(esd) %d*%d\n", img->y_size, img->x_size);
       for (j=0; j < img->y_size; j++)
        {   prg_printf( "#M(S) %3d :", j);
            for (i=0, m=j*xs; i < xs; i++, m++) 
            {   nf = img->frame[m];
               moy = s1[m]/nf;
               s = (s2[m] - nf*moy*moy)/ (nf-1.0+.00001);
               prg_printf( " %.1f(%5.1lf)", moy, sqrt(s));
              }
           if ( errno ){ printf(" errno=%d \n",errno); errno=0;}
			  else prg_printf("\n");
			  }
        }    
   if (set_limit != 0)
	for (i=0; i<size; i++) if ( img->frame[i] )
   {   if ( s1[i] < low_limit * img->frame[i] ) img->frame[i] = 0;
       }
   m = stat_info( img, 0);
   xy_fputinfo( stdout, img);
   raw_mi = img->info.mini - n;
   raw_ma = img->info.maxi + n;
   raw_mean = img->info.mean / n;
	passage = 0;
   prg_printf("\n# %d points, low_limit = %.1f raw_mean %d\n", m, low_limit, raw_mean);
   for (essai=0; essai < stat_nb; essai++)
   {   repas = 0;
	    if (essai == 0)
        {  lim_mi = raw_mi /n;
           lim_ma = raw_ma /n;
           }
        else
        {  if ( lim_mi < 0 ) lim_mi = (lim_mi - raw_mean) * (1-stat_low) + raw_mean;
           else  lim_mi = stat_low * (lim_mi - raw_mean) + raw_mean;
           lim_ma = stat_high * (lim_ma - raw_mean) + raw_mean;
           }   
       prg_printf("\n# studying counts between %d and %d on each frame\n", lim_mi, lim_ma);
        if ( lim_ma - lim_mi < 10 || 1.5*lim_mi >= lim_ma ) 
	{   prg_printf("# dynamics too low, breaking\n");
	    break;
	    }
   for (i=0; i < size; i++) sn[i] = img->frame[i]; 
#ifdef DEBUG
     prg_printf("DEBUG_1 %d points in x[0,%.0lf] y[0, %.0lf] max %d non ini \n",  
               m, gr_xma, gr_yma, gr_max);			  
#endif
   do
   {   memset( mat, 0, matsize*sizeof(double));
	    memset( vec, 0, vecsize*sizeof(double));
		 vma = lim_mi;
       vmi = lim_ma;    
       sma = 0;
		 smi = 1.0e59;
		 m=0;
#ifdef DEBUG
       prg_printf("DEBUG_2 stat_img %d repas %d gr_data %X size %d needed %d\n",  
                stat_img, repas, &gr_data, sizeof(gr_data), gr_data_size);			  
#endif
       if (stat_img && ( (repas++ == 0) || stat_img == 2) )
       {   memset(gr_data, 0, gr_data_size);
           gr_yma = 0; 
			  gr_max = 1;
#ifdef DEBUG
        prg_printf("DEBUG_3 %d points in x[0,%.0lf] y[0, %.0lf] max %d \n",  
		       m, gr_xma, gr_yma, gr_max);			  
#endif
			  for (i=0; i < size; i++) if ( sn[i] > 1 ) 
			  {  nf = sn[i];
              moy = s1[i] / nf;
              if ( moy < lim_mi || moy > lim_ma ) continue; 
              s = (s2[i] - nf*moy*moy) / (nf-1);
              if ( s > gr_yma) gr_yma = s + 1; 
				  }
		     gr_xma = 1+lim_ma;
			  sprintf(gr_name,"bm2stat%03d", passage++);
			  study = 1;
			  gr_img.name = gr_name;
			  } else study = 0;
#ifdef DEBUG
 prg_printf("DEBUG_4 %d points in x[0,%.0lf] y[0, %.0lf] max %d \n",  m, gr_xma, gr_yma, gr_max);			  
#endif
       for (i=0; i < size; i++) if ( sn[i] > 1 )  
       { nf = sn[i];
         moy = s1[i] / nf;
         if ( moy < lim_mi || moy > lim_ma ) { sn[i]=0; continue; }
         m++;
         if ( moy < vmi) vmi = moy;
         if ( moy > vma) vma = moy;
         s = (s2[i] - nf*moy*moy) / (nf-1);
 			if ( s > sma) sma = s;
			if ( s < smi ) smi = s;
         if (study) 
			{   gr_ix =  ( moy * GRAPH_SIZE) / gr_xma;
			    gr_iy =  ( s * GRAPH_SIZE) / gr_yma;
			    gr_ip = gr_iy*GRAPH_SIZE+gr_ix;
				 if ( ++gr_data[gr_ip] > gr_max ) gr_max = gr_data[gr_ip];
             if ( gr_ix <0 || gr_ix >= GRAPH_SIZE || gr_iy <0 || gr_iy >= GRAPH_SIZE )
                prg_printf(" error GR X %d Y %d moy=%.0lf %.0lf  s=%.0lf %.0lf  i %d nf %d s2=%.0lf\n", 
					 gr_ix, gr_iy, moy, gr_xma, s, gr_yma, i, nf, s2[i]);
			    }
	      if (d_value)
			{  d_val = rho * d_img->data[i];
				if (d_val > moy ) moy -= d_val; else moy = 0;
			   if (dark_coef) s -= dark_coef * d_val;
			   }
         for (v=vw=0; v<vecsize; v++)
			{  if ( v !=0 ) coef[v] = coef[v-1] * moy; else coef[0] = 1;
			   vec[v] += s * coef[v];
			   for (w=0; w<=v; w++, vw++)
				{  mat[vw] += coef[w]*coef[v];
				   }
				}
			}
		 if (study)
		 {   gr_img.info.maxi = 1 + gr_max;
			  prg_printf("# representation of %d points in x[0,%.0lf] y[0, %.0lf] max %d ", 
			      m, gr_xma, gr_yma, gr_max);
			  edf_write( &gr_img, T_COUNTS);
			  /* txt_write (gr_img); */
			  prg_printf("END # representation \n"); 
			  }
	    if (d_value == NULL || dark_coef != 0 )
		     mkk = chol_part( mat, vec, vecsize);
       if ( mkk )
       {   prg_printf ("# singular matrix ??? %d\n", mkk);
           return;
          }
       if ( m <= 1)
       {   prg_printf ("# %d obs : no regression [%.2lf->%.2lf]\n", m, vmi, vma);
           return;
          }
      ern = ers = ers2 = 0;
      for (i=0; i < size; i++)  if ( sn[i] > 1 )   
      {  nf = sn[i];
         moy = s1[i] / nf;
         s = (s2[i] - nf*moy*moy) / (nf-1);
	      if (d_value)
			{  d_val = rho * d_img->data[i];
				if (d_val > moy ) moy -= d_val; else moy = 0;
			   if (dark_coef) s -= dark_coef * d_val;
			   }
         s2c = 0;
         for (v=0; v<vecsize; v++)
			{  if ( v ) coef[v] = coef[v-1] * moy; else coef[0] = 1;
			   s2c += coef[v] * vec[v];
				}
         er =  s - s2c;
         ern +=1;
         ers2 += er*er;
         }
      residu = sqrt(ers2/(ern-vecsize));
      prg_printf ("# %d obs : S^2=%.3lf(%.3lf)",  m, vec[0], residu * sqrt(mat[0]));
      for (v=1; v< vecsize; v++)
		  prg_printf (" %+.3lg(%.3lg) %s^%d", vec[v], residu * sqrt(mat[((v+1)*(v+2))/2-1]), d_value?"(adu-d)":"adu", v);
		prg_printf ("%s [%.0lf->%.0lf] s2[%.0lf->%.0lf], res=%.2lf", 
           (vecsize) <= 1 ? ",":"\n#", vmi, vma, smi, sma, residu);
      prg_printf ("\n");
      rej = 0;
      ern = ers = ers2 = 0;
      ner2 = 0;    
      for (i=0; i < size; i++)  if ( sn[i] > 1 )   
      {  nf = sn[i];
         moy = s1[i] / nf;
         s = (s2[i] - nf*moy*moy) / (nf-1);
	      if (d_value)
			{  d_val = rho * d_img->data[i];
				if (d_val > moy ) moy -= d_val; else moy = 0;
			   if (dark_coef) s -= dark_coef * d_val;
			   }
         s2c = 0;
         for (v=0; v<vecsize; v++)
			{  if ( v ) coef[v] = coef[v-1] * moy; else coef[0] = 1;
			   s2c += coef[v] * vec[v];
				}
         er =  (s - s2c) / residu;
         if ( fabs(er) > 6.0 )
         {  rej++;
            if ( print & 128 ) prg_printf ("#REJ %3d*%3d  %8.2lf (o=%8.2lf, c=%8.2lf) er=%8.2lf\n",
               i%xs, i/xs, moy,  sqrt(s), s2c>0?sqrt(s2c):0, er);
            sn[i] = 0;
            }
          }
       prg_printf ("# removing %d pixels\n", rej);
       if ( oresidu == 0 || ( residu < oresidu && m))
       {   for (i=0; i<matsize; i++) omat[i] = mat[i];
           for (i=0; i<vecsize; i++) ovec[i] = vec[i];
           om = m;
           oresidu = residu;
			  ovmi = vmi;
			  ovma = vma;
			  omean = raw_mean;
           }
       } while(rej);
	   }
    if ( (repas > 1))
       {   memset(gr_data, 0, GRAPH_SIZE*GRAPH_SIZE*sizeof(COUNTS));
           gr_yma = 0; 
			  gr_max = 1;
			  for (i=0; i < size; i++) if ( sn[i] > 1 ) 
			  {  nf = sn[i];
              moy = s1[i] / nf;
              if ( moy < lim_mi || moy > lim_ma ) continue; 
              s = (s2[i] - nf*moy*moy) / (nf-1);
              if ( s > gr_yma) gr_yma = s + 1; 
				  }
		     gr_xma = 1+lim_ma;
			  sprintf(gr_name,"bm2stat%03d", passage++);
			  gr_img.name = gr_name;
			  for (i=0; i < size; i++) if ( sn[i] > 1 )  
          {  nf = sn[i];
             moy = s1[i] / nf;
             s = (s2[i] - nf*moy*moy) / (nf-1);
             gr_ix =  ( moy * GRAPH_SIZE) / gr_xma;
			    gr_iy =  ( s * GRAPH_SIZE) / gr_yma;
			    gr_ip = gr_iy*GRAPH_SIZE+gr_ix;
			    if ( ++gr_data[gr_ip] > gr_max ) gr_max = gr_data[gr_ip];
             if ( gr_ix <0 || gr_ix >= GRAPH_SIZE || gr_iy <0 || gr_iy >= GRAPH_SIZE )
               prg_printf(" error GR X %d Y %d %.0lf %.0lf  %.0lf %.0lf\n", gr_ix, gr_iy, moy, gr_xma, s, gr_yma);
			    }
		    gr_img.info.maxi = 1 + gr_max;
		   prg_printf("# representation of %d points in x[0,%.0lf] y[0, %.0lf] max %d ", 
			      m, gr_xma, gr_yma, gr_max);
		edf_write( &gr_img, T_COUNTS);
		   } /* is repas */
   if ( oresidu )
   {   prg_printf ("\n Best fit (Residual = %.2lf) on %d points\n", oresidu, om);
      prg_printf ("# %d obs : S^2=%.3lf(%.3lf)",  m, ovec[0], residu * sqrt(omat[0]));
      for (v=1; v< vecsize; v++)
		  prg_printf (" %+.3lg(%.3lg) %s^%d", ovec[v], residu * sqrt(omat[((v+1)*(v+2))/2-1]), d_value?"(adu-d)":"adu", v);
		prg_printf ("%s [%.0lf->%.0lf] s2[%.0lf->%.0lf], res=%.2lf", 
           (vecsize) <= 1 ? ",":"\n#", vmi, vma, smi, sma, residu);
      prg_printf ("\n Normalised expansion to N=%s/mean with mean=%.0lf\n",d_value?"(adu-d)":"adu", omean);
      prg_printf ("# (S/mean)^2=%.3lg",  ovec[0]/(omean*omean));
      for (v=1; v< vecsize; v++) prg_printf (" %+.3lg N^%d", ovec[v]*pow(omean,(double) v-2.0), v);
      prg_printf ("\n\n");
      } 
   else   prg_printf ("\n No data to analyse\n");
   if (sn) free(sn);
	free (gr_data);
   xy_freeimg( img, 2);
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
int chol_part (double * mat, double * vect, int n)
    /* perform Choleski decomposition : M = A * D * tA
       with A(i,i=1) ,j>i=>A(i,j)=0 and D diagonal;
       as result  M-1 = tB * D-1 * B with B = A-1
       the input matrix is symetrical and must be defined
       the storage requirements are minimized
       the input matrix is given as its low triangular part A(i,j) i<=j
       cf L.Leon,F.Millet in TurboC mathematiques p190-193, Eyrolles(Paris) 1988
       */
{   register i, j, k;
    int ret_val = 0;
    double  **rmat;
    double **amat;
    double *vtab, *dtab;
    /* this define minimize the storage requirements */
#define MINFLOAT 1e-25
#define bmat  amat
#define new_b vtab
    /* array of ptr on the lines of the low triangular part of mat */
    rmat = (double **) malloc (n*sizeof(double *));
    for (i=0; i<n; i++) rmat[i] = mat + ((i * (i+1)) / 2);
    /* array of ptr's on allocated lines of a low triangular array */
    amat = (double **) malloc (n*sizeof(double *));
    for (i=0; i<n; i++) amat[i] = 
         (double *) malloc ((i+1)*sizeof(double));
    /* array of values */
    vtab = (double *) malloc (n*sizeof(double));
    dtab = (double *) malloc (n*sizeof(double));
    bmat[0][0] = 1;
    amat[0][0] = 1;
    dtab[0] = rmat[0][0];
    if (fabs (dtab[0]) > MINFLOAT )
    {   /* calculate D and A values */
	for (k=1; k<n; k++)
	{   for (i=0, dtab[k] = rmat[k][k]; i<k; i++)
	    {   for (j=0, vtab[i]=0; j<=i; j++)
		   vtab[i] += bmat[i][j] * rmat[k][j];
		amat [k][i] = vtab[i] / dtab[i];
		dtab[k] -= amat[k][i] * vtab[i];
		if (fabs(dtab[k]) < MINFLOAT) ret_val = k+1;
		}
	    /* calculate B values */
	    if (ret_val==0)
	    {   for (i=0; i<k; i++)
		    for (j=i, new_b[i]=0; j<k; j++)
		       new_b[i] -= bmat[j][i] * amat[k][j];
		for (i=0; i<k; i++) bmat[k][i] = new_b[i];
		amat [k][k] = 1;
	        }      
            }
	    /* calculate the lower part of the original matrix */
	    for (j=0; j<n; j++)
	     for (i=0; i<=j; i++)
	      for (k=j, rmat[j][i]=0; k<n; k++)
	       rmat[j][i] += bmat[k][i] * bmat[k][j] / dtab[k];
	    /* le second membre */
	    for (i=0;i<n;i++)
	    {  for (j=0,vtab[i]=0;j<i;j++) vtab[i] += rmat[i][j] * vect[j];
	       for (j=i;j<n;j++)           vtab[i] += rmat[j][i] * vect[j];
	       }
	    for (i=0;i<n;i++) vect[i] = vtab[i];
	    }
	else ret_val = 1;
	free(dtab);
	free(vtab);
	for (i=n-1; i>=0; i--) free (amat[i]);
	free(amat);
	free(rmat);
	return(ret_val);
	}
/*-----------------------------------------------------------*/
int stat_info(IMAGE *img, char cas)  
/* similar to xy_info but take into account frames info */
{   long i, xy, v, xyo, size;
    double d, e, m;
    COUNTS *val = img->data;
	 FRAMES *frames = img->frame;
    size = 0;
    for (i=0; i<img->size; i++) if (frames[i] ) size++;
	 if (size == 0) return 0;
    for (i=0; i<img->size; i++) if (frames[i] ) { xyo = i; break; };
    if ( cas==0 || cas & 1)
    {   v = 0;
        for (i=0; i<img->size; i++) if (frames[i] && val[i] ) v++;
        img->info.nzero = v;
        }
    if (img->cosmic.sum_corrected == 1)
	 {  if ( cas==0 || cas & 2)
       {  v = val[xyo];
          xy = xyo;
          for (i=1; i<img->size; i++)  if (frames[i] && val[i] < v ) { v = val[i]; xy = i;}
          img->info.mini = v;
          img->info.x_min = xy % img->x_size;
          img->info.y_min = xy / img->x_size;
          }
       if ( cas==0 || cas & 4)
       {  v = val[xyo];
          xy = xyo;
          for (i=1; i<img->size; i++)  if (frames[i] ) if( val[i] > v ) { v = val[i]; xy =i; }
          img->info.maxi = v;
          img->info.x_max = xy % img->x_size;
          img->info.y_max = xy / img->x_size;
          }
       if ( cas==0 || cas & 8|| cas & 16)
       {  d = 0;
         for (i=0; i<img->size; i++)  if (frames[i] ) d += val[i];  
         img->info.mean = m = d / size;
         }
       if ( cas==0 || cas & 16)
       {  d = 0;
          for (i=0; i<img->size; i++)  if (frames[i] ) 
          {  e = val[i] - m;
             d += e*e; 
             } 
          img->info.sigma = sqrt( d /(size-1.0));
          }
		} else  /* cosmic.sum_corrected */
	 {  int used_frames = img->used_frames;
       if ( cas==0 || cas & 2)
       {  v = xy_valcor(img, xyo);
          xy = xyo;
          for (i=1; i<img->size; i++)  if (frames[i] ) 
			 if ( xy_valcor(img,i) < v ) { v = xy_valcor(img,i); xy = i;}
          img->info.mini = v;
          img->info.x_min = xy % img->x_size;
          img->info.y_min = xy / img->x_size;
          }
     if ( cas==0 || cas & 4)
     {   v = xy_valcor(img,xyo);
        xy = xyo;
        for (i=1; i<img->size; i++)  if (frames[i] ) if( xy_valcor(img,i) > v ) { v = xy_valcor(img,i); xy =i; }
        img->info.maxi = v;
        img->info.x_max = xy % img->x_size;
        img->info.y_max = xy / img->x_size;
        }
     if ( cas==0 || cas & 8|| cas & 16)
     {    d = 0;
         for (i=0; i<img->size; i++)  if (frames[i] ) d += xy_valcor(img,i);  
         img->info.mean = m = d / size;
        }
     if ( cas==0 || cas & 16)
     {    d = 0;
         for (i=0; i<img->size; i++)  if (frames[i] ) 
         {    e = xy_valcor(img,i) - m;
              d += e*e; 
              } 
         img->info.sigma = sqrt( d /(size-1.0));
         }
		}
	 return size;	 
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

