static char *cvs_id =" $Id: xy_grid.c,v 1.10 2003/06/27 13:39:48 berar Exp $ ";
/*-----------------------------------------------------------*/
/* grid correction xy_grid.c                                   */
/*-----------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#define DBG 1
#include "xy_def.h"
/*typedef struct {  int alloc, size;  double *xcor, *ycor; }  extern GRID_COR grid;*/
/* being here is initialized by defect */
GRID_COR grid_cor = {0,0,0,NULL,NULL,0,0,0,NULL};
static char * grid_mode = NULL;
char * grid_orig = NULL;
static int grid_xmin=0;
static int grid_ymin=0;
static int grid_xbind=1;
static int grid_ybind=1;
static int  grid_deg_xy (int i, int *x, int *y, int retcode);
static void grid_tabulate_pixel(double x, double y, GRID_COR *grid);
static double grid_cor_dx(double x, double y, GRID_COR *grid, double *cor);
static double grid_cor_dy(double x, double y, GRID_COR *grid, double *cor);
/*-----------------------------------------------------------*/
void grid_usage (void)
{   fprintf(stderr,  "\n grid usage parameters :\n");
    fprintf(stderr,  " GRID_AUTO = NONE (default), AUTO apply grid correction\n");
    fprintf(stderr,  " GRID_MODE = NONE (derault) FLAT, STRICT... see bm2grid.pdf\n");
    fprintf(stderr,  " GRID_DCOR... see bm2grid\n");
    fprintf(stderr,  " GRID_ORIG = CONVERT used for radial binding\n");
    fprintf(stderr,  " GRID_XMIN = needed to use only a part of the whole grid, GRID_YMIN \n");
    fprintf(stderr,  " GRID_XBIND = allow to use the whole grid with bindings, GRID_YBIND\n");
    fprintf(stderr,  " the XY_ORIEN parameter works after read, bind and mask\n");
    }                
/*-----------------------------------------------------------*/
int  grid_ini ( GRID_COR *grid, char * tag, char * arg)
{  int n;
   if ( prg_iniint(tag, arg, "GRID_DCOR", &n)) 
   {  grid_struct_ini ( grid, n); 
      return 1;
      } 
   if ( grid->xcor && prg_inidbln(tag, arg, "GRID_XCOR", grid->xcor, grid->size)) 
   {  grid->valid |= 1;
      return 1;
      }
   if ( grid->xcor && prg_inidblt(tag, arg, "GRID_XTAB", grid->xcor, grid->size)) 
   {  grid->valid |= 1;
      return 1;
      }
   if ( grid->ycor && prg_inidbln(tag, arg, "GRID_YCOR", grid->ycor, grid->size)) 
   {  grid->valid |= 2;
      return 1;
      }
   if ( grid->ycor && prg_inidblt(tag, arg, "GRID_YTAB", grid->ycor, grid->size)) 
   {  grid->valid |= 2;
      return 1;
      }
   if ( prg_inistr(tag, arg, "GRID_MODE", & grid_mode)) return 1;
   if ( prg_inistr(tag, arg, "GRID_ORIG", & grid_orig)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_XMIN", & grid_xmin)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_YMIN", & grid_ymin)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_XBIND", & grid_xbind)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_YBIND", & grid_ybind)) return 1;
   return 0;
   }
/*-----------------------------------------------------------*/
void  grid_struct_ini ( GRID_COR *grid, int size)
{   grid->alloc=grid->size=size;
    grid->valid=0;
    grid->tabulated.ok=0;
    if (grid->xcor) free (grid->xcor);
    if (grid->ycor) free (grid->ycor);
    grid->xcor = (double *) prg_alloc (__FILE__, "xcor",grid->size*sizeof(double),1);
    grid->ycor = (double *) prg_alloc (__FILE__, "ycor",grid->size*sizeof(double),1);
    grid->tabulated.value = (double *) prg_alloc (__FILE__, "tabulated",grid->size*sizeof(double),1);
    } 
/*-----------------------------------------------------------*/
void  grid_struct_def ( GRID_COR *grid, int size, int xo, int yo)
{   grid_struct_ini ( grid, size);
    grid->xcor[1]=1;
    grid->ycor[2]=1;
    grid->xcor[0]=xo;
    grid->ycor[0]=yo;
    grid->valid=grid->size=3;
    } 
/*-----------------------------------------------------------*/
void grid_cor_img ( GRID_COR *grid, IMAGE *img, int scale )
{  float  *surface;
   double *value;
   long sx,sy,sj;
   long tx,ty,tj;
   double x,xx,y,yy,v,s,surf;
   COUNTS *i_value = img->data;
   FRAMES *frame = img->frame;
   FRAMES *grid_frame;
   long tab[50],itab=0;
   printf ("\n#%s:grid_cor_img  '%s' size=%d(%dx%d)\n", __FILE__, img->name, 
            img->size,img->x_size,img->y_size);
   if (grid->size==0 || grid->valid!=3)
      v_error(__FILE__, "grid functions are not valid (look at .ini file)");
   surface = (float *) prg_alloc(__FILE__, "surface", img->size * sizeof(float), 1);
   value = (double *) prg_alloc(__FILE__, "corrected values", img->size * sizeof(double), 1);
   if ( ! i_value ) v_error(__FILE__, "no data in %s", img->name);
   grid_frame = (FRAMES *) prg_alloc(__FILE__, "frame", img->size * sizeof(FRAMES), 1);
   if (!grid_frame )
     if ( grid_mode && !strstr(grid_mode,"STRICT") ) 
           printf(" unable to alloc frame for grid correction and GRID_MODE not STRICT\n");
     else grid_mode="STRICT";
   for (sy=0; sy<img->y_size; sy++)
   {  double gsy=grid_pix_ycor(sy,grid); 
      for (sx=0,sj=sy*img->x_size; sx<img->x_size; sx++,sj++)
      {  long txb,txe,tyb,tye;
         double xb, xe, yb, ye, dxx, dyy;
         double gsx=grid_pix_xcor(sx,grid);
         /* coordinates gsx are in grid coords no problems with orien,,, */
	 if (frame && frame[sj]==0) continue;
	 x=grid_cor_xpos(gsx, gsy, grid);
         y=grid_cor_ypos(gsx, gsy, grid);
         dxx=grid_cor_dx(gsx, gsy, grid, grid->xcor);
         dyy=grid_cor_dy(gsx, gsy, grid, grid->ycor);
         surf=grid_cor_surf(gsx, gsy, grid);
         txb=xb=x-dxx/2;
         txe=xe=x+dxx/2;
         tyb=yb=y-dyy/2;
         tye=ye=y+dyy/2;
         for (tx=txb; tx<=txe;tx++)
         {  double dx;
            if(tx<0 || tx>=img->x_size) continue;
            if (xb < tx )
            {  if ( xe < tx )        continue;
               dx = ( xe <= tx+1 ) ? xe-tx : 1;
               }
            else if ( xb > tx+1 )   continue;
            else dx = ( xe <= tx+1 ) ? xe-xb : tx+1-xb;
            for (ty=tyb; ty<=tye;ty++)
            {  double dy;
               if(ty<0 || ty>=img->y_size) continue;
               if (yb < ty )
               {  if ( ye < ty )        continue;
                  dy = ( ye <= ty+1 ) ? ye-ty : 1;
                  }
               else if ( yb > ty+1 )   continue;
               else dy = ( ye <= ty+1 ) ? ye-yb : ty+1-yb;
               tj = ty*img->x_size+tx;
               s = dx*dy/surf;
               value[tj] += s * i_value[sj];
               surface[tj] += s*surf;
               if ( grid_frame ) grid_frame[tj]++;
            }  } /*for  tx, ty*/ 
      } }  /*for  sx, sy*/ 
   if ( grid_mode && strstr(grid_mode,"FLAT") )
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj]/surface[sj]+0.5;
         else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=0.5) i_value[sj]=value[sj]/surface[sj]+0.5;
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]>=0.5) ? 1 : 0;
         }
      }
   else
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj]+0.5;
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  tj = 0;
         for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=1.0) i_value[sj]=value[sj]+0.5;
           else  if ( surface[sj]>0.5) 
           {   i_value[sj]=value[sj]/surface[sj]+0.5;
               tj++;
               }   
           else i_value[sj]=0;
          if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]<0.5) ? 0 : 1;
         printf ("# %d pixels corrected for border effects\n", tj);
         }
      }
   free(value);
   free(surface);
   if (img->frame) free(img->frame);
   img->frame=grid_frame;
   }
/*-----------------------------------------------------------*/
char * coef_grid_name(int i)
{  static char model[9];
   int x,y;
   grid_deg_xy(i,&x,&y,0);
   sprintf (model,"x^%dy^%d", x, y);
   return model;
   } 
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
double grid_pix_surf(double x, double y, GRID_COR *grid)
{  return grid_cor_surf(grid_pix_xcor(x,grid), grid_pix_ycor(y,grid), grid);
   }
/*-----------------------------------------------------------*/
double grid_pix_xcor(double x, GRID_COR *grid)
{  double rx;
   if (grid_xbind>0) rx=x*grid_xbind+grid_xmin-grid->xcor[0];
   else     rx=x*grid_xbind-grid_xmin+grid->xcor[0];
   return rx;
   }
/*-----------------------------------------------------------*/
double grid_pix_ycor(double y, GRID_COR *grid)
{  double ry;
   if (grid_ybind>0) ry=y*grid_ybind+grid_ymin-grid->ycor[0];
   else     ry=y*grid_ybind-grid_ymin+grid->ycor[0];
   return ry;
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
static xdbg=0;
static ydbg=0;
/*-----------------------------------------------------------*/
double grid_cor_xpos(double x, double y, GRID_COR *grid)
{  double res, rx;
   int j;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++) res+= grid->xcor[j]*grid->tabulated.value[j];
   if (grid_xbind>0) rx=(res-grid_xmin)/grid_xbind;
   else     rx=(res+grid_xmin-2*grid->xcor[0])/grid_xbind;
/*   if (xdbg++ % 100==0) printf (" x %lf y %lf    res %lf--> X %lf\n",x,y, res,rx);*/
   return rx;
   }
/*-----------------------------------------------------------*/
double grid_cor_ypos(double x, double y, GRID_COR *grid)
{  double res,ry;
   int j;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++) res+= grid->ycor[j]*grid->tabulated.value[j];
   if (grid_ybind>0) ry=(res-grid_ymin)/grid_ybind;
   else     ry=(res+grid_ymin-2*grid->ycor[0])/grid_ybind;
/*   if (ydbg++ % 100==0) printf (" x %lf y %lf    res %lf--> Y %lf\n",x,y, res,ry);*/
   return ry;
   }
/*-----------------------------------------------------------*/
double grid_cor_surf(double px, double py, GRID_COR *grid)
{  double dxx, dyx, dxy, dyy;
   dxx=grid_cor_dx(px, py, grid, grid->xcor);
   dyy=grid_cor_dy(px, py, grid, grid->ycor);
   dxy=grid_cor_dy(px, py, grid, grid->xcor);
   dyx=grid_cor_dx(px, py, grid, grid->ycor);
   return dxx*dyy-dxy*dyx;
   }
/*-----------------------------------------------------------*/
double grid_cor_der (int i, double x, double y, GRID_COR *grid)
{  grid_tabulate_pixel(x, y, grid);
   return grid->tabulated.value[i];
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
static int grid_deg_xy (int i, int *x, int *y,int retcode)
{  int n=1;
   int p=1;
   while (i >= p) p+=++n;
   p-=n--;
   *y=i-p;
   *x=n-*y;
   if (retcode == 0) return n;   /* x+y degree */
   /* x(1) , y (2) derivative xy position */
   if (retcode == 1) 
   {  if (*x) return i-n; else return -1; }
   if (retcode == 2) 
   {  if (*y) return i-n-1; else return -1; }
   }
/*-----------------------------------------------------------*/
static double grid_cor_dx(double x, double y, GRID_COR *grid, double *cor)
{  double res;
   int j;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++)
   {  int i,dx, dy;
      i=grid_deg_xy(j,&dx,&dy,1);
      if ( i>=0) res+=cor[j]*dx*grid->tabulated.value[i];
      }
   return res;
   }
/*-----------------------------------------------------------*/
static double grid_cor_dy(double x, double y, GRID_COR *grid, double *cor)
{  double res;
   int j;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++)
   {  int i,dx, dy;
      i=grid_deg_xy(j,&dx,&dy,2);
      if ( i>=0) res+=cor[j]*dy*grid->tabulated.value[i];
      }
   return res;
   }
/*-----------------------------------------------------------*/
/* the usage of tabulated values reduces strongly the time due to pow call */
/*-----------------------------------------------------------*/
static void grid_tabulate_pixel(double x, double y, GRID_COR *grid)
{  int j;
   if( x==grid->tabulated.gsx && y==grid->tabulated.gsy && grid->tabulated.ok==1) return;
   for (j=0; j<grid->size;j++) 
   {  int dx, dy;
      grid_deg_xy(j,&dx,&dy,0);
      grid->tabulated.value[j]=pow(x,dx)*pow(y,dy);
      }
    grid->tabulated.gsx=x;
    grid->tabulated.gsy=y;
    grid->tabulated.ok=1;
    }
/*-----------------------------------------------------------*/
